/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_JSOL                                                     */
/* Tabela : JUSTSOLI                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_JSOL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_JSOL
GO

CREATE TRIGGER DTULTATU_JSOL
ON JUSTSOLI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'JUSTSOLI', null, 'CDJUSTSOL='+ CDJUSTSOL+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE JUSTSOLI
      SET DTULTATUJSOL = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(JUSTSOLI.CDJUSTSOL,0) = ISNULL(INSERTED.CDJUSTSOL,0)) AND
            (ISNULL(JUSTSOLI.DSJUSTSOL,0) = ISNULL(INSERTED.DSJUSTSOL,0));
   END;
END;
GO

