<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;

use Zeedhi\DevOps\Model\Projectmanagement\Entities;

class ErrorClassification extends \Doctrine\ORM\EntityRepository {
    
    public function findErrorClassification($organizationId, $filters)
    {
        $sql = <<<SQL
            SELECT ECL.ID, ECL.DESCRIPTION, ECL.STATUS
              FROM ERROR_CLASSIFICATION ECL
             WHERE ECL.STATUS <> :inactive
               AND ORGANIZATION_ID = :organizationId
          $filters
          ORDER BY DESCRIPTION
SQL;
        $params = array(
            'organizationId' => $organizationId,
            'inactive' => Entities\ErrorClassification::DELETED
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql,$params);
    }
    
    public function findAllErrorClassification($organizationId)
    {
        $sql = <<<SQL
            SELECT ECL.ID AS ERROR_CLASSIFICATION_ID , ECL.DESCRIPTION AS ERROR_CLASSIFICATION
              FROM ERROR_CLASSIFICATION ECL
             WHERE ECL.STATUS <> :inactive
               AND ORGANIZATION_ID = :organizationId
SQL;
        $params = array(
            'organizationId' => $organizationId,
            'inactive' => Entities\ErrorClassification::DELETED
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql,$params);
    }
}